#include <stdio.h>                  /* Programm colpicksec_c */
#include <stdlib.h>
#include <qdos.h>
#include <qptr.h>
#include <libqx0.h>

void (*_consetup)()=NULL;           /* keine Initialisierung des con device */
char _conname[] = "con_2x1a0x0";    /* unterdrcke Probleme beim Start */
char *_endmsg  = NULL;              /* keine Meldung beim Beenden des Jobs */
char _PROG_NAME[] = "colpicksec";   /* Name des Jobs */

long wm_vectr=0;

long AMOV(struct WM_wwork *wwk, struct WM_litm *lit) {
  short dx,dy;
  wwk->wstat->evnt |= PT_WMOVE;     /* Setze bit fr move im event vector  */
  wm_chwin(wwk,&dx,&dy);            /* Verschiebe Fenster */
  wwk->wstat->litem[lit->item] = WSI_MKAV;  /* loose item status anwhlbar */
  return wm_ldraw(wwk,-1);          /* Neuzeichnen der loose items, deren */
}                                   /* change bit in der status area gesetzt ist */
struct WM_action amove = { JSR, wm_actli, AMOV};  /* action routine interface */

long APICK(struct WM_wwork *wwk, struct WM_litm *lit) {
  unsigned short color;
  int err = 0;
  
  wwk->wstat->litem[lit->item] = WSI_MKAV;  /* loose item status anwhlbar */

  color = 0xFFFE;
  err = qx0_colpick_secondary(&color);

  sd_clear(wwk->chid, -1);
  printf("\n\n\n\n    err = %d color = %d\n", err, color);

  return wm_ldraw(wwk, 0);
}
struct WM_action acpick = { JSR, wm_actli, APICK};  /* action routine interface */

main()
{
   static struct WM_wstat ws =  /* window status area */
   {
     NULL,             /* *wwork                Zeiger auf working def. */
     NULL,             /* *wdef                 Zeiger auf window def. */
     0,                /* chid        Kanal ID des Fensters in dem Mauszeiger */
     0,0,0,            /* swnr, xpos, ypos  sub-window nr. und Mauszeigerpos. */
     0,0,              /* kstk, kprs        Tastendruck, evtl. andauernder T. */
     0,                /* evnt                  event vector */
     0,0,0,0,          /* xsiz, ysiz, xorg, yorg  Gre, Ursprung des subwin. */
     0,0,              /* ptpsx, ptpsy          absolute Mauszeigerposition */
     FORM_QL4,0,0,     /* wmode           Bildschirmmodus, 8 unbenutzte bytes */

     NULL,               /* *ciact        Zeiger auf aktuelle action routine */
     -1,                 /* citem                aktuelles item */
     0,0,0,              /* cibrw, cipap, cispr  Border, Paper von item  */
     0,0,0,0,            /* cihxs,ys, cihxo,yo   hit area in absoluten Koord. */

     {0,0,0,0,0,0,0,0}   /* litem[40]            1 Statusbyte pro loose item */
   };

#define  ninfo    0        /* Zahl der information windows */
#define  ninob    0        /* Zahl der information objects */
#define  nlitm    2        /* Zahl der loose items */
#define  nappl    0        /* Zahl der application sub-windows */

static QD_TEXTI(qstr_cpick, "choose color");

   static struct WM_litm litm[nlitm+1] =            /* loose items */
   {
    { 24,10,               /* xsize, ysize    Gre */
      26,2,                /* xorg, yorg      Lage des loose item */
      0,0,                 /* xjst, yjst   Lage des Objekts relativ xorg,yorg */
      TYP_SPRITE,K_MOVE,   /* type, skey      Typ und Anwahltaste */
      &wm_sprite_move,           /* *pobj           Zeiger auf Objekt */
      0,                   /* item            item Nummer */
      &amove},             /* *pact           Zeiger auf action routine */
    { 12*6,12,             /* xsize, ysize    Gre */
      26,14,               /* xorg, yorg      Lage des loose item */
      0,0,                 /* xjst, yjst   Lage des Objekts relativ xorg,yorg */
      TYP_TEXT,'C',        /* type, skey      Typ und Anwahltaste */
      &qstr_cpick,         /* *pobj           Zeiger auf Objekt */
      0,                   /* item            item Nummer */
      &acpick},            /* *pact           Zeiger auf action routine */
    {-1}
   };

   static struct WM_wwork ww = /* window working definition */
   {
/* header block */
     &ws,                   /* *wstat;              Verweis auf status area */
     NULL,                  /* *wscale              Zeiger auf window def. */
     0,                     /* chid                 Kanal ID des Fensters */
     NULL,                  /* *pprec               Zeiger auf pointer record */
     0,                     /* psave                Pos. des Mauszeigers */
     0,0,0,0,               /* 4 zero               unbenutzt */
     NULL,                  /* *splst               Zeiger auf sprite list */
/* window definition block */
     300,150,               /* xsize, ysize        Fensterabmessungen */
     140,10,                /* xorg, yorg     Lage des Mauszeigers im Fenster */
     2,                     /* flag                Schatten */
     1,CL_MBORD,CL_MBACK,   /* borw, borc, papr    Borderbreite,-farbe, paper */
     NULL,                  /* *sprite        Zeiger auf Sprite f. Mauszeiger */
                            /* loose item Attribute */
     1,CL_MHIGH,            /* curw, curc          Rahmenbreite,-farbe des */
                                               /*  aktuellen loose item */
     /* Hintergrundfarbe, Textfarbe, Zeiger auf blob und pattern fr
        gesperrte, anwhlbare und angewhlte loose items  */
     CL_MPUNAV,CL_MIUNAV,NULL,NULL,  /* uback, uink, *ublob, *upatt gesperrt */
     CL_MPAVBL,CL_MIAVBL,NULL,NULL,  /* aback, aink, *ablob, *apatt anwhlbar */
     CL_MPSLCT,CL_MISLCT,NULL,NULL,  /* sback, sink, *sblob, *spatt angewhlt */

     NULL,                  /* *help               Zeiger auf help definition */

     ninfo,ninob,NULL,      /* ninfo, ninob, *pinfo Anzahl, Zeiger auf Listen */
     nlitm,litm,            /* nlitm, *plitm        der information windows,  */
     nappl,NULL             /* nappl  *pappl        loose items u. appl. win. */
   };
   unsigned short color;
   int err = 0;

   ww.chid=fgetchid(stdout);        /* setze Kanal ID in working definition */
   if (!(wm_vectr = (long)wm_findv(ww.chid))) exit (-1); /*ist WMAN vorhanden?*/
   ws.wwork = &ww;                  /* Verweis auf working def. */
   wm_prpos (&ww,-1,-1);            /* positioniere Fenster */
   wm_wdraw (&ww);                  /* zeichne Fenster */
   if (wm_rptr(&ww)) exit(-1);      /* warten auf window events */
}
